/* IBM Confidential
* OCO Source Materials
* 5724-U98, 5655-V48, 5724-U50, 5655-V46
* © Copyright IBM Corp. 2013
* The source code for this program is not published or other -
* wise divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
*/
define(["dojo/domReady!",
        "dojo/_base/declare",
        "dojo/_base/lang",
    	"dojo/store/Memory",
    	"dojo/data/ObjectStore",
    	"dojo/_base/array",
    	"idx/form/TextBox",
    	"idx/form/Textarea",
    	"dijit/form/Button",
    	"dijit/layout/TabContainer",
    	"dijit/layout/ContentPane",
    	"dojo/dom-construct",
    	"dojox/form/Uploader",
    	"dojox/form/uploader/plugins/IFrame",    	
    	"dojox/grid/DataGrid",
        "dijit/_Widget",
        "dijit/_TemplatedMixin",
        "dijit/_WidgetsInTemplateMixin",
        "dojo/text!./templates/DsiWizardSecondPage.html",
        "dojo/i18n!./nls/widget_resources"
        ],
        function(dDomReady,
        		 dDeclare,					// (dojo/_base/declare)
				 dLang,						// (dojo/_base/lang)
				 dMemory,                   // (dojo/store/Memory)
				 dObjectStore,              // (dojo/data/ObjectStore)
				 array,                     // (dojo/_base/array)
				 dTextBox,					// (idx/form/TextBox)
				 dTextarea,					// (idx/form/Textarea)
				 dButton,                   // (dijit/form/Button)
				 dTabContainer,             // (dijit/layout/TabContainer)
				 dContentPane,              // (dijit/layout/ContentPane)
				 dUploader,					// (dojox/form/Uploader)
				 dIFrame,					// (dojox/form/uploader/IFrame)
				 dDomConstruct,				// (dojox/dom-construct)
				 dDataGrid,                 // (dojox/grid/DataGrid)
		         dWidget,					// (dijit/_Widget)
		         dTemplatedMixin,			// (dijit/_TemplatedMixin)
		         dWidgetsInTemplateMixin,	// (dijit/_WidgetsInTemplateMixin)
		         templateText,				// (dojo/text!./templates/DsiWizardSecondPage.html)
		         resources)
{
	//Wizard Page variable to support the selected jar in the grid
	var gridItemSelected;
	/**
	 * @name dsiwidget.wizard.DsiWizardSecondPage
	 * @class The LoginFrame provides the standard login screen.
	 * @augments dijit._Widget
	 * @augments dijit._TemplatedMixin
	 * 
	 */
	return dDeclare("wizard.DsiWizardSecondPage", [dWidget,dTemplatedMixin,dWidgetsInTemplateMixin],
			  /**@lends dsiwidget.wizard.DsiWizardSecondPage#*/		
	{
		baseClass: "dsiWizardSecondPage",
		templateString: templateText,
	
		
		cannotGoBack: false,
		cannotGoNext: false,
		jarUploader: null,
		wizard: null,

		//Clean method	
		startup: function(){
			this.inherited(arguments);
			this.connect(this.hostTextBox.domNode, "onkeyup", this._handleFieldChange);
			this.connect(this.hostTextBox.domNode, "onmouseover", this.showHostName);
			this.connect(this.hostTextBox.domNode, "onmouseout", this.hideHostName);
			this.connect(this.portTextBox.domNode, "onkeyup", this._handleFieldChange);
			this.connect(this.dbTextBox.domNode, "onkeyup", this._handleFieldChange);
			this.connect(this.userNameTextBox.domNode, "onkeyup", this._handleFieldChange);
			this.connect(this.passwordTextBox.domNode, "onkeyup", this._handleFieldChange);
			this.connect(this.customURITextBox.domNode, "onkeyup", this._handleFieldChange);
			this.connect(this.testConnButton, "onClick", dLang.hitch(this, "_testConnection"));
			this.connect(this.fileBrowser, "onChange", this._onUploaderChange);
			this.connect(this.grid, "onSelectionChanged", this.updateUploadURL);
			this.connect(this.grid, "onRowMouseOut", this.hideJarToolTip);
			this.connect(this.grid, "onRowMouseOver", this.showJarToolTip);
			this._configureInputFields();
		},		
		
		postCreate: function() {
			this.inherited(arguments);
		},
		 
		resize: function() {
			this.inherited(arguments);
			this.mainContainer.resize();
		},
		
		checkTabs:function(){
			if (pageWizardMode =="new"){ 
				if (dsiWizardFirstPage.vendorComboBox.get("value")=="Oracle" ||
					dsiWizardFirstPage.vendorComboBox.get("value")=="SQL Server"){
					dijit.byId("customURI").set("disabled", false);
				}else{
					dijit.byId("customURI").set("disabled", true);
					var tabbedPane = dijit.byId("tabPane");
					tabbedPane.selectChild(dijit.byId("standardURI"));
				}
			}else{
				var rowData = connectionGrid.getItem(connectionGridSelectedIndex);
				if (rowData.vendor =="Oracle" ||
					rowData.vendor =="SQL Server"){
					dijit.byId("customURI").set("disabled", false);
				}else{
					dijit.byId("customURI").set("disabled", true);
					var tabbedPane = dijit.byId("tabPane");
					tabbedPane.selectChild(dijit.byId("standardURI"));
				}
			}
			
		},
	
		
		getDescription: function() {
			var descriptionMessage = "";
			require(["dojo/dom"], function(dom){
				dom.byId("pageDescrDiv").style.height="5em";
				dom.byId("pageDescrDiv").style.visibility="visible";
	    	});
			var fieldsReq = "<table style='border-style:none; margin-top:10px'><tr><td><div class='oneuiMsgInfo16' /></td>"
				fieldsReq += "<td style='padding-left:5px'>" + resources['allFieldsMandatoryMessage'] + "</td></tr></table>";
			if (inBootStrapMode){
				descriptionMessage = "<b>" + resources['wp2OCMDescription'] + "</b><br/>" + fieldsReq;
			}else{
				descriptionMessage = "<b>" + resources['wp2Description'] + "</b><br/>" + fieldsReq;
			}
			return descriptionMessage;
		},
		
		
//Get the list of available jars based upon the DBMS vendor and version
		
		_getAvailableJarListFromBootStrap: function(){
		
			var jarListURL = "";
			
			jarListURL = url + "BOOTSTRAP/DRIVER/DETAILS/" + dsiWizardFirstPage.vendorComboBox.get('value') + "/" + dsiWizardFirstPage.versionComboBox.get('value');
			console.log("URL in _getAvailableJarListFromBoostrap: " + jarListURL); 
			 var xhrArgs = {
			            url: jarListURL,		          
			            handleAs: 'json',
			            sync: true,
			            load: dLang.hitch(this, "_handleGetAvailableJarList"),
						error: dLang.hitch(this, "_handleError")
			    }
			 var deferred = dojo.xhrGet(xhrArgs);
		},	
		
		pageInit: function(){
			this.hostTextBox.reset();
			this.portTextBox.reset();
			this.dbTextBox.reset();
			this.userNameTextBox.reset();
			this.passwordTextBox.reset();
			this.customURITextBox.reset();
			this._updateWizardButtons();
			this.resize();
		},
		
		pageLoad: function(){
			this._clearMessages();
			this.clearJarGrid();
			this._getDataStoreTemplate();
			if(inBootStrapMode){
				this.checkBootStrapMode();
				this._getAvailableJarListFromBootStrap();
			}else{
				this._getAvailableJarList();
			}
			if (pageWizardMode == "edit") { // in Edit mode
				this._getDataStoreInfo();
			}
			this._initUploadGrid();
			this._updateWizardButtons();
			this.hostTextBox.focus();
			this.jarList= [""];
			this.checkTabs();
		},
		
		//Check for BootStrap initialization parameters
		checkBootStrapMode: function(){
			if (bootstrapPayload != ""){
				if (bootstrapPayload.vendor == dsiWizardFirstPage.vendorComboBox.get('value')  && bootstrapPayload.version == dsiWizardFirstPage.versionComboBox.get('value')){
					this._handleGetCommonDataStoreInfo(bootstrapPayload);
				}else{
					this.clearFields();
				}
			}
		},		
		//Clear fields if another venfor version is selected.
		clearFields: function(data){
			console.log ("Clearing  Fields")
			this.hostTextBox.set("value", "");
			this.dbTextBox.set("value", ""); 
			this.userNameTextBox.set("value", "");		
			this.passwordTextBox.set("value", "");
		},
		
		isReady: function(){
			return((((this.hostTextBox.get('value') != "" || this.hostTextBox.get('value') != "localhost" || this.hostTextBox.get('value') != "127.0.0.1") && 
					this.portTextBox.get('value') != "" && 
					this.dbTextBox.get('value') != "")||
					this.customURITextBox.get('value') !="") && 
					this.userNameTextBox.get('value') && 
					this.passwordTextBox.get('value') &&  
					jarList[0].availability == resources['jarAvailableText']);
		},
		
		_configureInputFields: function() {
			this.hostTextBox.set("label", resources['hostLabel']);
			this.portTextBox.set("label", resources['portLabel']);
			this.dbTextBox.set("label", resources['databaseLabel']);
			this.userNameTextBox.set("label", resources['usernameLabel']);
			this.passwordTextBox.set("label", resources['passwordlabel']);
			this.hostTextBox.set("invalidMessage", resources['hostInvalidMessage']);
			this.portTextBox.set("invalidMessage", resources['portInvalidMessage']);
			this.dbTextBox.set("invalidMessage", resources['dbInvalidMessage']);
			this.userNameTextBox.set("invalidMessage", resources['usernameInvalidMessage']);
			this.passwordTextBox.set("invalidMessage", resources['passwordInvalidMessage']);
			this.testConnButton.set("label", resources['testConnectionButtonLabel']);
			this.hostHelp.set("message", resources['hostHoverhelpMessage']);
			this.dbHelp.set("message", resources['dbHoverhelpMessage']);
		},
		
		//Get the datastore template based upon the selected vendor and version
		//This template is used to construct the json object used to create the data store entry
		
		_getDataStoreTemplate: function(){
			var vendor = "";
			var version = "";
			var oDirName = "";
			
			vendor = dsiWizardFirstPage.vendorComboBox.get('value');
			version = dsiWizardFirstPage.versionComboBox.get('value');
			
			var vendorVersionTemplateURL = url + "TEMPLATE/" + vendor +"/"+ version;
			console.log("URL: " + vendorVersionTemplateURL); 
			var xhrArgs = {
			            url: vendorVersionTemplateURL,
			            sync: true,
			            handleAs: 'json',
			            load: dLang.hitch(this, "_handleGetDataStoreTemplate"),
						error: dLang.hitch(this, "_handleError")
			   }
			var deferred = dojo.xhrGet(xhrArgs);
			
		},
		
		//Get the datastore by id number for an edit operation
		
		_getDataStoreInfo: function(){
			var rowData = connectionGrid.getItem(connectionGridSelectedIndex);
			var datastoreIdURL = url + rowData.id;
			console.log("URL: " + datastoreIdURL); 
			var xhrArgs = {
			            url: datastoreIdURL,		          
			            handleAs: 'json',
			            load: dLang.hitch(this, "_handleGetDataStoreInfo"),
						error: dLang.hitch(this, "_handleError")
			    }
			var deferred = dojo.xhrGet(xhrArgs);		
		},
		
		
		//Get the list of available jars based upon the DBMS vendor and version
		
		_getAvailableJarList: function(){
			var jarListURL = "";
			jarListURL = url + "DRIVER/DETAILS/" + dsiWizardFirstPage.vendorComboBox.get('value') + "/" + dsiWizardFirstPage.versionComboBox.get('value');
			console.log("URL in _getAvailableJarList: " + jarListURL); 
			var xhrArgs = {
			            url: jarListURL,		          
			            handleAs: 'json',
			            load: dLang.hitch(this, "_handleGetAvailableJarList"),
						error: dLang.hitch(this, "_handleError")
			    }
			 var deferred = dojo.xhrGet(xhrArgs);
		},
		
		
		//Handler to process the listing of available jars based upon the DBMS vendor and version
		
		_handleGetAvailableJarList: function(data){
			var availJarList = null;
			var jList = new Array(data.fileList.length);
			for (i=0; i<data.fileList.length;i++){
				availJarList = data.fileList[i];
				var filename = availJarList.filename;
				vendorJarFile = filename;
				var rawUploadTS = availJarList.uploadTimestamp;
				var uploadTimestamp = new Date(availJarList.uploadTimestamp)
				var uploadTSdisplay = uploadTimestamp.toLocaleDateString() + " " + uploadTimestamp.toLocaleTimeString();
				jList[i] = {"filename": filename,"availability": resources['jarAvailableText'],"dateuploaded": uploadTSdisplay};
			}
			// Lets bring these two arrays together nicely		
			for (j=0;j<jList.length;j++){
				var fname1 = jList[j].filename;
				for (z=0;z < jarList.length;z++){
					var fname2 =jarList[z].filename;
					if (fname1 == fname2){
						jarList[z] = jList[j];
					}
				}
			}
			if(availJarList){
				this._initUploadGrid();
			}
			this._initUploader();
			this._checkTestConnectionState();
			this._updateWizardButtons();
		},
		
		
		//Handler to process the retrieval of the datastore template based on user specified vendor and version
		//and set the default port and jdbc driver values
		_handleGetDataStoreTemplate: function(data){
			var portNumber = data.jdbcConnectionInformation.additionalProperties['port.number'];
			this.portTextBox.set("value", portNumber);
			var rawJarList = null;
			
			//Construct Jar List from default and those available	
			//var rawJarList = new Array(data.jdbcConnectionInformation.additionalProperties.jarList);
			if (data.vendor=="Oracle"){
				rawJarList = data.jdbcConnectionInformation.additionalProperties.jarList.split(";");
			}else{
				rawJarList = new Array(data.jdbcConnectionInformation.additionalProperties.jarList);
			}
			for(i=0; i<rawJarList.length; i++){
				vendorJarFile = rawJarList[i];
				jarList[i] = {"filename": rawJarList[i], 
                        "availability": "", 
                        "dateuploaded": ""};
			}
			this._initUploadGrid();		
		},
		
		//Handler for datastore info
		//Refactor this
		_handleGetDataStoreInfo: function(data){
			this._handleGetCommonDataStoreInfo(data);
		},
		
		//Handler BootStrap datastore Info
		//Refactor this
		_handleGetCommonDataStoreInfo: function(data){
			var customURI = data.jdbcConnectionInformation.additionalProperties.OPTIM_OVERRIDE_URL_KEY;
			var tabbedPane = dijit.byId("tabPane");
			if (customURI!= null && customURI.length >0){
				this.customURITextBox.set("value", customURI);
				tabbedPane.selectChild(dijit.byId("customURI"));
			}else{
				tabbedPane.selectChild(dijit.byId("standardURI"));
				this.hostTextBox.set("value", data.jdbcConnectionInformation.additionalProperties.host);
				if (data.jdbcConnectionInformation.additionalProperties['port.number'] != null) {
					this.portTextBox.set("value", data.jdbcConnectionInformation.additionalProperties['port.number']);
				}
				this.dbTextBox.set("value", data.jdbcConnectionInformation.additionalProperties['org.eclipse.datatools.connectivity.db.databaseName']);
			}
			this.userNameTextBox.set("value", data.userName);		
			this.passwordTextBox.set("value", data.password);
		},

		
		_handleError: function(error){
			//404 on retrieve of jar list is okay
			var jarListCodeIndex;
			if(!inBootStrapMode){
				jarListCodeIndex = error.message.indexOf("/datastore/DRIVER/DETAILS/");
			}else{
				jarListCodeIndex = error.message.indexOf("/datastore/BOOTSTRAP/DRIVER/DETAILS/");
			}
			var errMsg = error.xhr.statusText;
			if(jarListCodeIndex >= 0){
				this._initUploadGrid();
				this._initUploader();
				
			}
			else {
				if (errMsg == "") {
					errMsg = resources['unknownErrorMessage'];
				}
				console.log(error.xhr.status+" "+error.xhr.statusText);
				this._populateResultMessage("oneuiMsgError16", errMsg, "messageDiv");
			}
			this._checkTestConnectionState();
			this._updateWizardButtons();
		},
		
		//Default handler for textbox changes
		_handleFieldChange:function(){
			this._clearMessages();
			this._checkTestConnectionState();
			this._updateWizardButtons();
		},

		_updateWizardButtons: function() {
			wizard = this.getParent().getParent().getParent(); //->StackContainer->ContentPane(center)->BorderContainer(wizard)
			wizard._checkButtons();
		},
		
		showHostName: function(e){
			if (dsiWizardSecondPage.hostTextBox.get('disabled')== true){
				var domNode = dijit.byId('hostTextBox').domNode;
				var hostname = dsiWizardSecondPage.hostTextBox.get('value');
				dijit.showTooltip(hostname,domNode,["after"]);
			}
		},
		
		hideHostName: function(e){
			if (dsiWizardSecondPage.hostTextBox.get('disabled')== true){
				var domNode = dijit.byId('hostTextBox').domNode;
				dsiWizardSecondPage.hostTextBox.get('value');
				dijit.hideTooltip(domNode);
			}
		},
		
		showJarToolTip: function(e){
			var jarGrid = this.grid;
			var jarFileName = jarGrid.store.getValue(jarGrid.getItem(e.rowIndex), "filename");
			var jarLocation = jarFileName + resources['jarToolTipInformation'];
			var domNode = dijit.byId('jGrid').domNode; //domNode to which the tooptip must point to
		    dijit.showTooltip(jarLocation, domNode,["before"]);
		},

		hideJarToolTip: function (){
			var domNode = dijit.byId('jGrid').domNode; //domNode to which the tooptip must point to
		    dijit.hideTooltip(domNode);
		},
		
	    _initUploadGrid: function(ObjectStore, Memory){
	    	var dataDisplay = "";
	    	var dataStore = null;
	    	var layout = null;
	    	if(jarList[0] != " "){
	    		dataDisplay = jarList;
	    	} 
	    	else{
	    		dataDisplay = jarList[0] = {"filename": "", "availability": resources['jarNotAvailableText'], "dateuploaded": ""};
	    	}
	    	dataStore = new dObjectStore({objectStore:new dMemory({ data: dataDisplay})});
	    	layout = [
	    	         	  {name: resources['fileNameColumn'], field: "filename", width: "20%"},
	    	         	  {name: resources['availColumn'], field: "availability", width: "25%",
		    	         	 formatter:function(avail, rowIdx, cell) {
		 	         			var displayStatus = "<table style='border-style:none;'><tr><td><div class='";
		 	         			if (avail == resources['jarAvailableText']) {
		 	         				displayStatus += "oneuiMsgSuccess16' /></td><td style='padding-left:5px'>" + avail;
		 	         			} else {
		 	         				displayStatus += "oneuiMsgError16' /></td><td style='padding-left:5px'>" + resources['jarNotAvailableText'];
		 	         			}
		 	         			displayStatus += "</td></tr></table>";
		 	         			return displayStatus;
		 	         		  }
	    	         	  },
	    	         	  {name: resources['uploadColumn'], field: "dateuploaded", width: "54%"}
	    	         	 ];
	    		if (this.grid.store != null) {
	    			this.grid.store.close();
	    		}
	    		this.grid.set('structure',layout);
	    		this.grid.set('items', dataDisplay);
	    		this.grid.set('store', dataStore);
		    	this.resize();
		   	if (this.grid.selection.selectedIndex < 0 || this.grid.selection.selectedIndex >= this.grid.items.length) {
		    		//set default selection to 0
		    		this.grid.selection.clear();
		    		this.grid.selection.setSelected(0, true);
		    }
	    },
	    
//  Needed to change the upload URL everytime a different row is clicked.
	    updateUploadURL: function(e){
	    	if (this.jarUploader == null) {
	    		return;
	    	}
	    	this.gridItemSelected = this.grid.selection.selectedIndex;
	    	var selected = this.grid.selection.getSelected();
	        var rowData = selected[0];
	        console.log("selected row: " + rowData);
	        if (rowData == null) {
	        	return;
	        }
	        var fname = rowData.filename
	        var avail = rowData.availability
	        var uploadURL = 
	        console.log("SelectedItem is" + fname); 
	        this.jarUploader.set('url', uploadURL);
	        if ((pageWizardMode == "new" || pageWizardMode == "edit") && !inBootStrapMode){
	    		uploadURL = url + "DRIVER/" + dsiWizardFirstPage.vendorComboBox.get('value') +"/"+ dsiWizardFirstPage.versionComboBox.get('value') +"/"+ fname;
	    	}else if ((pageWizardMode == "new" || pageWizardMode == "edit") && inBootStrapMode){
	    		uploadURL = url + "BOOTSTRAP/DRIVER/" + dsiWizardFirstPage.vendorComboBox.get('value') +"/"+ dsiWizardFirstPage.versionComboBox.get('value') +"/"+ fname;
	    	}
	    	this.jarUploader.set('url', uploadURL);
	    	var uploadLabel = resources['uploadButtonLabel'];
			if (rowData.availability == resources['jarAvailableText']) {
				uploadLabel = resources['replaceButtonLabel'];
			}
			this.jarUploader.set('label', uploadLabel);
			this._checkTestConnectionState();
	    },
	    
	    
	    _testConnection: function(){    	
	    	this._setButtonsState(true);
	    	this._clearMessages();
	    	var vendor = dsiWizardFirstPage.vendorComboBox.get('value');
	    	var version = dsiWizardFirstPage.versionComboBox.get('value');
	    	var getDstorURL = url + "TEMPLATE/" +vendor + "/"+version;
	    	var payload = null;
	    	var rsp = dojo.xhrGet({
	            url: getDstorURL,
	            sync: true,
	            handleAs: "json",
	            handle: function(response) {
	                payload = response
	            	return response;
	            }
	    	});
	    	
	    	console.log("URL: " + payload);
	    	var testConnURL = url + "TEST";
	    	console.log("URL: " + testConnURL);	
	    	
	    	var hostname = this.hostTextBox.get('value');
	    	var dbPort = this.portTextBox.get("value");
	    	var uName = this.userNameTextBox.get("value");
	    	var pWord = this.passwordTextBox.get("value");
	    	var dbName = this.dbTextBox.get("value");
	    		
	    	//Replace with field values
	    	if (inBootStrapMode){
	    		payload.datastoreType = "STARTUP";
	    	}else{
	    		payload.datastoreName = dbName;
				payload.datastoreType = "DIRECTORY";	
	    	}
	    	if (dijit.byId("standardURI").get("selected")==true){
	    		payload.jdbcConnectionInformation.additionalProperties.host = hostname
	    		payload.jdbcConnectionInformation.additionalProperties['database.server'] = hostname;
	    		payload.jdbcConnectionInformation.additionalProperties['port.number'] = dbPort;
	    		payload.jdbcConnectionInformation.additionalProperties['org.eclipse.datatools.connectivity.db.databaseName'] = dbName;
	    	}else{
	    		payload.datastoreName = "CUSTOMTEMP";
	    		payload.jdbcConnectionInformation.additionalProperties['OPTIM_OVERRIDE_URL_KEY'] =this.customURITextBox.get("value");
	    		
	    	}
			payload.userName =  uName;
			payload.password = pWord;
	    	console.log("URL: " + testConnURL); 
	    	var xhrArgs = {
	                url: testConnURL,	          
	                postData: dojo.toJson(payload),	 
	                handleAs: 'json',
	                headers: POST_HEADERS,
	                load: dLang.hitch(this, "_handleTestConnection"),
					error: dLang.hitch(this, "_handleTestConnFailure")
	         }    	
	    	require(["dojo/dom"], function(dom){
	    		node = dom.byId("jarUploader");
	    	});
	    	dijit.byId('testConnectionProcessing').show();
	    	var deferred = dojo.xhrPost(xhrArgs);  
	    },
		
	    _handleTestConnection: function(data){    	
	    	this._setButtonsState(false);
	    	this._updateWizardButtons();
	    	dijit.byId('testConnectionProcessing').hide();
	    	this._populateResultMessage("oneuiMsgInfo16", resources['connectionSuccessfulMessage'], "messageDiv");
	    },
		
	    _handleTestConnFailure: function(data){
	    	this._setButtonsState(false);
	    	this._updateWizardButtons();
	    	dijit.byId('testConnectionProcessing').hide();
	    	this._populateResultMessage("oneuiMsgError16", resources['connectionFailedMessage'], "messageDiv");
	    },
	    //Helper function to set main page button states based upon the data store grid state
		
	    _setButtonsState: function(state){
	    	wizard = this.getParent().getParent().getParent(); //->StackContainer->ContentPane(center)->BorderContainer(wizard)
			wizard._checkButtons();
			this.testConnButton.set('disabled',state); 
    		this.jarUploader.set('disabled',state);
	    	if(state){		
	    		wizard._setButtonStates(state);
	    	}else{
	    		wizard._checkButtons();
	    	}    	
	    },
		
	    _checkTestConnectionState: function(){
	    	var rowData = this.grid.getItem(0);
	    	var haveJars = false;
	    	
	    	//Handling for Oracle's triple jars
	    	if (this.grid.items.length>1){
	    		var rowData2 = this.grid.getItem(1);
	    		var rowData3 = this.grid.getItem(2);
	    		haveJars = rowData.availability == resources['jarAvailableText'] && rowData2.availability == resources['jarAvailableText'] && rowData3.availability == resources['jarAvailableText'];
	    	}else{
	    		haveJars = rowData != null && rowData.availability == resources['jarAvailableText'];
	    	}
	    	if (!dijit.byId('customURI').get('selected')){
	    	
	    		if((this.hostTextBox.get("value").length > 0 ||
	    				this.hostTextBox.get("value") != "localhost" || this.hostTextBox.get("value") != "127.0.0.1") &&
	    				this.portTextBox.get("value").length > 0 &&
	    				this.dbTextBox.get("value").length > 0 &&
	    				this.userNameTextBox.get("value").length > 0 &&
	    				this.passwordTextBox.get("value").length > 0 &&
	    				haveJars)
	    		{
	    			this.testConnButton.set('disabled',false);
	    		}else{
	    			this.testConnButton.set('disabled',true);
	    		}
	    	}else{
	    		if(this.customURITextBox.get("value").length >0 &&
	    				this.userNameTextBox.get("value").length > 0 &&
	    				this.passwordTextBox.get("value").length > 0 &&
	    				haveJars)
	    		{
	    			this.testConnButton.set('disabled',false);
	    		}else{
	    			this.testConnButton.set('disabled',true);
	    		}	
	    	}
	    },
		
	    _initUploader: function(Uploader){
	    	var vendor = "";
	    	var version = "";
	    	
			vendor = dsiWizardFirstPage.vendorComboBox.get('value');
			version = dsiWizardFirstPage.versionComboBox.get('value');
	    	
	    	var getDstorURL = url + "TEMPLATE/" +vendor + "/"+version;
	    	var payload = null;
	    	var rsp = dojo.xhrGet({
	            url: getDstorURL,
	            sync: true,
	            handleAs: "json",
	            handle: function(response) {
	                payload = response
	            	return response;
	            }
	    	});
	    	
	    	vendorJarFile = payload.jdbcConnectionInformation.additionalProperties['jarList'];
	    	
	    	var uploadURL = "";
	    	
	    	if ((pageWizardMode == "new" || pageWizardMode == "edit") && !inBootStrapMode){
	    		uploadURL = url + "DRIVER/" + dsiWizardFirstPage.vendorComboBox.get('value') +"/"+ dsiWizardFirstPage.versionComboBox.get('value') +"/"+ vendorJarFile;
	    	}else if ((pageWizardMode == "new" && inBootStrapMode) || (pageWizardMode == "edit" && inBootStrapMode)){
	    		uploadURL = url + "BOOTSTRAP/DRIVER/" + dsiWizardFirstPage.vendorComboBox.get('value') +"/"+ dsiWizardFirstPage.versionComboBox.get('value') +"/"+ vendorJarFile;
	    	}
	    	//added by TD for debugging
	    	
	    	console.log("URL: " + uploadURL);	

	    	var node;
			require(["dojo/dom"], function(dom){
	    		node = dom.byId("jarUploader");
	    	});
			var uploadLabel = resources['uploadButtonLabel'];
			if (jarList[0].availability == resources['jarAvailableText']) {
				uploadLabel = resources['replaceButtonLabel'];
			}
			if(!node){
				this.jarUploader = new dojox.form.Uploader({
					   id: "jarUploader",
		               label: uploadLabel,
					   multiple: false,
					   uploadOnSelect: true,
					   force: "iframe",
					   onComplete: dLang.hitch(this, "_handleUploadComplete"),
					   onChange: dLang.hitch(this, "_handleUploadProgress"),
					   onError: dLang.hitch(this, "_handleUploadError"),
					   url: uploadURL    												
					   });
				dojo.byId("jarForm").appendChild(this.jarUploader.domNode);
				this.jarUploader.startup();
			} else {
				this.jarUploader.set('url', uploadURL);
				this.jarUploader.set('label', uploadLabel);
			}
	    },
		
	    _handleUploadComplete: function(data){
	    	dijit.byId('jarUploadProcessing').hide();
	    	var errMsg = resources['uploadFailedMessage'];
	    	switch(data.responseStatus){
				case 200: 
				case 201:
					var uploadTimestamp = new Date(data.uploadTimestamp);
					var uploadTSdisplay = uploadTimestamp.toLocaleDateString() + " " + uploadTimestamp.toLocaleTimeString();
			    	var jarFilename = data.filename;
					//Make sure that an index is selected
			    	if (!this.gridItemSelected){
			    		this.gridItemSelected = 0;
			    	}
			    	jarList[this.gridItemSelected] = {"filename": jarFilename, 
							   	"availability": resources['jarAvailableText'], 
							   	"dateuploaded": uploadTSdisplay};
			    	this._initUploadGrid();
			    	this._initUploader();
			    	this._checkTestConnectionState();
			    	this._updateWizardButtons();
			    	this._populateResultMessage("oneuiMsgInfo16", resources['uploadSuccessfulMessage'], "messageDiv");
			    	
			    	//Reset upload button
			    	var selected = this.grid.selection.getSelected();
			    	var rowData = selected[0];
			    	var uploadLabel = resources['uploadButtonLabel'];
			    	this.jarUploader.set('label', uploadLabel);
			    	if (rowData.availability == resources['jarAvailableText']) {
			    		uploadLabel = resources['replaceButtonLabel'];
			    	}
			    	this.jarUploader.set('label', uploadLabel);
					break;
				case 203:
					this.handleNewUploadError(data);
					break;
				case 417:
					errMsg += "  " + resources['uploadFailedSuffix1'];
				default:
					if (data.responseStatus == undefined){
						this.handleInvalidJar(data);
					}else{
						this._handleUploadError(errMsg);
					}				
					
	    	}
	    },
	    
	    handleInvalidJar: function(data){
	    	dijit.byId('jarUploadProcessing').hide();
	    	this._clearMessages();
	    	handleDitaMsg(data);
	    },
	    
	    _handleUploadError: function(errMsg){
	    	dijit.byId('jarUploadProcessing').hide();
	    	if (errMsg == "") {
	    		errMsg = resources['uploadFailedMessage'];
	    	}
	    	if (errMsg == resources['uploadFailedMessage']) {
	    		errMsg += "  " + resources['uploadFailedSuffix2'];
	    	}
	    	this._populateResultMessage("oneuiMsgError16", errMsg, "messageDiv");
	    },
		
	    _handleUploadProgress: function(){
	    	dijit.byId('jarUploadProcessing').show();
	    },
		
	    _clearMessages: function() {
	    	require(["dojo/dom"], function(dom){
			    dom.byId("messageDiv").innerHTML = "";
	    	});
	    },
		
	    _populateResultMessage: function(imgClass, msg, div) {
	    	var result = this._formatResultTable(imgClass, msg);
    		require(["dojo/dom"], function(dom){
				dom.byId(div).innerHTML = result;
	    	});
	    },
		
	    _formatResultTable: function(imgClass, msg) {
	    	var resultTable = "<table style='border-style:none'><tr><td><div class='" + imgClass + "' /></td><td style='padding-left:5px'>" + msg + "</td></tr></table>"; 
	    	return resultTable; 
	    },

	    setDbFieldsReadOnly: function(bool){
	    	this.hostTextBox.set("disabled", bool);
			this.portTextBox.set("disabled", bool);
			this.dbTextBox.set("disabled", bool); 
	    },
	    
//	   This will ensure theat the contents of the grid are cleared when the page is closed or reloaded
//	    
	    clearJarGrid:function (){
	    	if (this.grid != null && this.grid.store != null){ 
	    		for ( x=0; x< this.grid.store.objectStore.data.length; x++){
	    			this.grid.store.deleteItem(this.grid.store.objectStore.data[x]);
	    			console.log("Item :" +x);
	    		}
	    		data = jarList[0] = {"filename": "", 
	  				  "availability": resources['jarNotAvailableText'], 
	  				  "dateuploaded": ""};
	    		this.grid.store.save();
	    		this.grid.set('store',new dObjectStore({objectStore:new dMemory({ data: data})}));
	    		this.grid.resize();
	    	}
	    }
		
	});
});
